/* ---------------------------------------------------------------------------------- */
/* st2sco.c */
/*
  GIORGI Jean-Francois
  Campus de Beaulieu
  35042 Rennes Cedex FRANCE
  tel: 99 36 20 00
  e-mail: giorgi@irisa.fr
*/

/* ---------------------------------------------------------------------------------- */
#include "st.h"
#include <stdio.h>

/* ---------------------------------------------------------------------------------- */
ST_Score *sts;
BOOL play;
char *ProgName;
int numpat;
ST_Note  sts_patterns[MAX_PAT][PAT_LEN][NUM_VOICES];
BYTE *(Samples[MAX_INST]);
char outfn[300];
char *calloc();
/* ---------------------------------------------------------------------------------- */
read_module(modfilename)
char *modfilename;
{
  FILE *inf;
  int i;
  int ss;

  sts = (ST_Score *)calloc(SZ_ST_SCORE,1);
  inf = fopen(modfilename,"r");
  if (inf == NULL) {
    fprintf(stderr,"error opening file %s\n",modfilename);
    exit();
  }
  fread(sts,SZ_ST_SCORE,1,inf);
  fprintf(stderr,"score name : %s\n",sts->sts_name);
  fprintf(stderr,"sts_length : %x\n",(int)sts->sts_length);
  fprintf(stderr,"sts_mark : %x\n",(int)sts->sts_mark);
  fprintf(stderr,"sts_ident : %lx\n",sts->sts_ident);
  if (sts->sts_ident != IDENT_MARK) { 
    fprintf(stderr,"bad sts_ident\n");
  }

  numpat = 0;
  for (i=0;i<MAX_LENGTH;i++) {
    if (sts->sts_patpos[i]>numpat) numpat = sts->sts_patpos[i];
  }
  numpat++;
  fprintf(stderr,"NUMPAT = %d\n",numpat);
  for (i=0;i<sts->sts_length;i++) {
    fprintf(stderr,"sts_patpos[%d] : %d\n",i,sts->sts_patpos[i]);
  }

  /* sts_patterns = (ST_Note *)calloc(sizeof(ST_Pattern),numpat); */
  fread(&(sts_patterns[0][0][0]),sizeof(ST_Pattern),numpat,inf);

  fclose(inf);
  for (i=0;i<MAX_INST;i++) {
    if (sts->sts_instr[i].sti_midsize != 0) {
      ss = (int)sts->sts_instr[i].sti_midsize;
      ss *= 2;
      fprintf(stderr,"sts_instr[%d].sti_name : %s (%d,%x)\n",i,sts->sts_instr[i].sti_name,ss,sts->sts_instr[i].sti_volume);
    }
  }
}
/* ---------------------------------------------------------------------------------- */
stdump(stdfn)
char *stdfn;
{
  FILE *df;
  int i;
  ULONG ss;
  int t,c,v,ic,pat;
  int oct,pitch;
  ST_Note stnote;
  int tempo;
  df = fopen(stdfn,"w");

  for (i=0;i<MAX_INST;i++) {
    if (sts->sts_instr[i].sti_midsize != 0) {
      ss = (int)sts->sts_instr[i].sti_midsize;
      ss *= 2;
      fprintf(df,"|--------------------------------------------------|\n");
      fprintf(df,"| %02x : %-22s                   |%02x|\n",i+1,sts->sts_instr[i].sti_name,sts->sts_instr[i].sti_volume);
    }
  }
  tempo = 6;
  for(t=0;t<(play==TRUE?sts->sts_length:numpat);t++) {
    pat = play==TRUE?sts->sts_patpos[t]:t;
    fprintf(df,"|--------------------------------------------------|\n");
    for (c=0;c<PAT_LEN;c++) {
      for (v=0;v<NUM_VOICES;v++) {
         stnote = sts_patterns[pat][c][v];
	 if (play == TRUE && stnote.stn_ctrl == STC_BREAK) {
	   fprintf(df,"|BREAK -->\n");
	   v = NUM_VOICES;
	   c = PAT_LEN;
	 }
	 if (play == TRUE && stnote.stn_ctrl == STC_JUMP) {
	   if (stnote.stn_data>t) {
	     fprintf(df,"|JUMP -->\n");
	     v = NUM_VOICES;
	     c = PAT_LEN;
	   }
	 }
      }
      if (c==PAT_LEN) continue;
      fprintf(df,"|%02d",c);
      for (v=0;v<NUM_VOICES;v++) {
         stnote = sts_patterns[pat][c][v];
	 if (stnote.stn_period == 0) 
           fprintf(df,"|---- %x%x %x%02x",stnote.stn_upperins,stnote.stn_ins,stnote.stn_ctrl,stnote.stn_data);
         else
           fprintf(df,"|%04x %x%x %x%02x",stnote.stn_period,stnote.stn_upperins,stnote.stn_ins,stnote.stn_ctrl,stnote.stn_data);
	 if (play == TRUE && stnote.stn_ctrl == STC_SPEED) {
           tempo = stnote.stn_data;
	 }
          
      }
      fprintf(df,"|%d\n",tempo);
    }
  }
  fprintf(df,"|--------------------------------------------------|\n");
  fclose(df);
}
/* ---------------------------------------------------------------------------------- */
usage()
{
  fprintf(stderr,"usage : %s [-p] st-module dumpfile\n",ProgName);
  exit();
}
/* ---------------------------------------------------------------------------------- */
main(argc,argv)
int argc;
char **argv;
{
  int i;

  ProgName = argv[0];

  play = FALSE;
  i = 1;
  if (argc==4) {
    if (strcmp(argv[1],"-p")) usage();
    play = TRUE;
    i = 2;
  }
  else if (argc != 3) usage();

  read_module(argv[i]);

  stdump(argv[i+1]);
}
/* ---------------------------------------------------------------------------------- */
